/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_COMM_MANAGER_DISPATCHER_H__
#define __TR_COMM_MANAGER_DISPATCHER_H__

#include <sys/types.h>
#include <sys/epoll.h>

#include "trbase.h"
#include "trdata.h"
#include "trevent.h"

#include "tr/comm_worker.h"

TR_CLASS(TR_CommManagerDispatcher) {
	TR_EXTENDS(TR_CommManager);

	TR_Set workers;
};

#define TR_commManDispAddWorker(this, worker) \
	(TR_setAdd((this)->workers, (worker))

TR_INSTANCE_INIT(TR_CommManagerDispatcher);
TR_CLASSVARS_DECL(TR_CommManagerDispatcher) {
	TR_CV_EXTENDS(TR_EventHandler);
};

#endif // __TR_COMM_MANAGER_DISPATCHER_H__

// vim: set ts=4 sw=4:

