/**
 * \file
 * This exists only as a base type for all protocols.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_COMM_WORKER_H__
#define __TR_COMM_WORKER_H__

#include <sys/types.h>
#include <semaphore.h>

#include "trbase.h"
#include "trio.h"

typedef struct s_TR_WorkerShm {
	struct c_TR_Socket socket;
	sem_t              semaphore;
} s_TR_WorkerShm;
typedef s_TR_WorkerShm * sptr_TR_WorkerShm;

TR_CLASS(TR_CommWorker) {
	const char * const name;
	pid_t              pid;
	TR_Socket          socket;
	sptr_TR_WorkerShm  shm;
};

TR_INSTANCE_INIT(TR_CommWorker);
TR_CLASSVARS_DECL(TR_CommWorker) {};

#endif // __TR_COMM_WORKER_H__

// vim: set ts=4 sw=4:

