/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_CONNECT_ENTRY_POINT_H__
#define __TR_CONNECT_ENTRY_POINT_H__

#include <sys/types.h>

#include "trbase.h"
#include "trio.h"

#include "tr/comm_end_point.h"

TR_CLASS(TR_ConnEntryPoint) {
	TR_EXTENDS(TR_CommEndPoint);
};
TR_INSTANCE_INIT(TR_ConnEntryPoint);
TR_CLASSVARS_DECL(TR_ConnEntryPoint) {
	TR_CV_EXTENDS(TR_CommEndPoint);
};

#define TR_CET_EVENT_ACC_READY (TR_CEP_EVENT_MAX + 1)
#define TR_CET_EVENT_MAX       ((size_t)TR_CET_EVENT_ACC_READY)

#endif // __TR_CONNECT_ENTRY_POINT_H__

// vim: set ts=4 sw=4:

