/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_DATAGRAM_SERVICE_H__
#define __TR_DATAGRAM_SERVICE_H__

#include <sys/types.h>

#include "trbase.h"
#include "trevent.h"
#include "trdata.h"

#include "tr/comm_end_point.h"
#include "tr/proto_message.h"

TR_CLASS(TR_DatagramService) {
	TR_EXTENDS(TR_CommEndPoint);
};
TR_INSTANCE_INIT(TR_DatagramService);
TR_CLASSVARS_DECL(TR_DatagramService) {
	TR_CV_EXTENDS(TR_CommEndPoint);
};

TR_ProtoMessage TR_dsNextMessage(TR_DatagramService);
int             TR_dsCompose(TR_DatagramService, TR_ProtoMessage);

#endif // __TR_DATAGRAM_SERVICE_H__

// vim: set ts=4 sw=4:

