/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_INTERFACE_COMM_END_POINT_H__
#define __TR_INTERFACE_COMM_END_POINT_H__

#include <sys/types.h>

#include "trbase.h"
#include "trio.h"

#include "tr/comm_end_point.h"
#include "tr/proto_message.h"

typedef TR_ProtoMessage (* fptr_TR_cepNextMessage)(void *, TR_RemoteData *);
typedef size_t          (* fptr_TR_cepCompose)(void *, TR_ProtoMessage);

TR_INTERFACE(TR_CommEndPoint) {
	TR_IFID;
	fptr_TR_cepNextMessage     nextMessage;
	fptr_TR_cepCompose         compose;
};

inline
TR_ProtoMessage
TR_cepNextMessage(void * _this, TR_RemoteData * data)
{
	TR_ProtoMessage callret;
	TR_RETCALL(_this, TR_CommEndPoint, nextMessage, callret, data);
	return callret;
}

inline
size_t
TR_cepCompose(void * _this, TR_ProtoMessage message)
{
	size_t callret;
	TR_RETCALL(_this, TR_CommEndPoint, compose, callret, message);
	return callret;
}

#endif // __TR_INTERFACE_COMM_END_POINT_H__

// vim: set ts=4 sw=4:
