/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_INTERFACE_COMM_MANAGER_H__
#define __TR_INTERFACE_COMM_MANAGER_H__

#include <sys/types.h>

#include "trbase.h"
#include "trevent.h"

#include "tr/comm_end_point.h"

typedef TR_EventDone (* fptr_TR_commManagerAddEndpoint)(void *, TR_CommEndPoint);
typedef TR_EventDone (* fptr_TR_commManagerSelect)(void *, TR_Event, unsigned long);
typedef TR_EventDone (* fptr_TR_commManagerPollWrite)(void *, TR_Event);
typedef TR_EventDone (* fptr_TR_commManagerPollRead)(void *, TR_Event);
typedef TR_EventDone (* fptr_TR_commManagerDisableWrite)(void *, TR_Event);
typedef TR_EventDone (* fptr_TR_commManagerDisableRead)(void *, TR_Event);
typedef TR_EventDone (* fptr_TR_commManagerClose)(void *, TR_Event);

TR_INTERFACE(TR_CommManager) {
	TR_IFID;
	fptr_TR_commManagerAddEndpoint  addEndpoint;
	fptr_TR_commManagerSelect       select;
	fptr_TR_commManagerPollWrite    pollWrite;
	fptr_TR_commManagerPollRead     pollRead;
	fptr_TR_commManagerDisableWrite disableWrite;
	fptr_TR_commManagerDisableRead  disableRead;
	fptr_TR_commManagerClose        close;
};

void TR_commManagerAddEndpoint(void *, TR_CommEndPoint);

#endif // __TR_INTERFACE_COMM_MANAGER_H__

// vim: set ts=4 sw=4:
