/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_PROTOCOL_MESSAGE_RAW_H__
#define __TR_PROTOCOL_MESSAGE_RAW_H__

#include <sys/types.h>
#include <stdint.h>

#include "trbase.h"
#include "trio.h"

#include "tr/proto_message.h"

TR_CLASS(TR_ProtoMessageRaw) {
	TR_EXTENDS(TR_ProtoMessage);

	uint16_t   size;
	uint16_t   size_done;
	char     * data;
};
TR_INSTANCE_INIT(TR_ProtoMessageRaw);
TR_CLASSVARS_DECL(TR_ProtoMessageRaw) {};

#endif // __TR_PROTOCOL_MESSAGE_RAW_H__

// vim: set ts=4 sw=4:

