/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_SIMPLE_CLIENT_H__
#define __TR_SIMPLE_CLIENT_H__

#include <sys/types.h>
#include <stdint.h>

#include "trbase.h"
#include "trevent.h"

#include "tr/comm_manager.h"
#include "tr/comm_end_point.h"
#include "tr/io_handler.h"
#include "tr/protocol_handler.h"
#include "tr/protocol.h"
#include "tr/proto_message.h"
#include "tr/interface/comm_manager.h"

TR_CLASS(TR_SimpleClient) {
	TR_EXTENDS(TR_EventHandler);

	TR_CommEndPoint    endpoint;
	TR_CommManager     comm_manager;
	TR_ProtoMessage    request;
	TR_ProtoMessage    response;
	TR_IoHandler       io_handler;
	TR_ProtocolHandler protocol_handler;
	TR_EventDispatcher dispatcher;
	int                send_issued;
	TR_Timer           timer;
};
TR_INSTANCE_INIT(TR_SimpleClient);
TR_CLASSVARS_DECL(TR_SimpleClient) {
	TR_CV_EXTENDS(TR_EventHandler);
};

TR_ProtoMessage TR_simpleClientIssue(
		TR_SimpleClient, TR_ProtoMessage, unsigned long);

#define TR_simpleClientClassCleanup()                 \
	TR_eventHandlerClassCleanup(TR_ProtocolHandler);  \
    TR_eventHandlerClassCleanup(TR_IoHandler);        \
    TR_eventHandlerClassCleanup(TR_CommManagerEpoll); \
	TR_eventHandlerClassCleanup(TR_SimpleClient)

#endif // __TR_SIMPLE_CLIENT_H__

// vim: set ts=4 sw=4:

