/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "trio.h"

#include "tr/comm_end_point.h"

int
TR_commEndPointRead(TR_CommEndPoint this, TR_RemoteData * data_ptr)
{
	*data_ptr = TR_socketRecv(this->transport, this->read_chunk_size);

	if (! *data_ptr)                     return -1; // ment to trigger a close
	if (*data_ptr == (void*)-1)          return -2; // remote close... shutdown
	if (*data_ptr == TR_emptyRemoteData) return FALSE; // read blocked

	return TRUE;
}

// vim: set ts=4 sw=4:
