/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "trdata.h"
#include "trevent.h"

#include "tr/comm_end_point.h"
#include "tr/comm_manager.h"
#include "tr/_comm_manager.h"

TR_EventDone
TR_commManagerShutdownRead(void * _this, TR_Event event)
{
	TR_CommManager this = _this;
	TR_CommEndPoint endpoint = (TR_CommEndPoint)event->subject;

	if (! TR_socketFinRd(endpoint->transport)) {
		TR_socketShutdownRead(endpoint->transport);
	}

	if (TR_socketFinRdWr(endpoint->transport)) {
		// close
		TR_ISSUE_IO_CLOSE_EVENT(this, event->subject);
	}

	if (! TR_cepHasPendingData(endpoint)) {
		TR_ISSUE_IO_SHUT_WRITE_EVENT(this, event->subject);
	}

	TR_setDelete(this->read, event->subject);

	return TR_EVENT_DONE;
}

// vim: set ts=4 sw=4:
