/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trio.h"

#include "tr/server.h"
#include "tr/protocol.h"
#include "tr/connect_entry_point.h"

void
TR_serverBindTcp(
		TR_Server     this,
		const char  * host,
		int           port,
		TR_Protocol   proto)
{
	TR_Socket socket = (TR_Socket)TR_new(
			TR_TcpSocket,
			TR_logger,
			host,
			port, 0);

	TR_serverAddEndpoint(
			this,
			TR_new(TR_ConnEntryPoint, socket, proto, CEP_DEFAULT_READ_SIZE));
}

// vim: set ts=4 sw=4:
