/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "trevent.h"

#include "tr/simple_client.h"
#include "tr/proto_message.h"

TR_ProtoMessage
TR_simpleClientIssue(
		TR_SimpleClient this,
		TR_ProtoMessage request,
		unsigned long   timeout)
{
	TR_ProtoMessage retval;

	TR_timerSetMil(this->timer, timeout);
	this->request     = request;
	this->response    = NULL;
	this->send_issued = FALSE;

	TR_eventDispatcherStart(((TR_EventHandler)this)->dispatcher[0]);

	retval = this->response;
	this->request = this->response = NULL;

	return retval;
}

// vim: set ts=4 sw=4:
